﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

using Templates;

namespace InteractionSample
{
    public class TestInteraction : ExecutionAsync
    {
        // T1 & T2 should access and use the same _myThreadInstance instance
        private StringBuilder _myThreadInstance;
        public TestInteraction(StringBuilder myThreadInstance)
        {
            _myThreadInstance = myThreadInstance;
        }

        protected override void DoWork(object sender, DoWorkEventArgs e)
        {
            while (!CancellationPending)
            {
                // none of params can be passed - only default constructor available
                T1 t1 = new T1(); 

                // this is the only point where assigment can be done
                t1.GenerationEnvironment = _myThreadInstance;

                // generate output by T1 & T2 (as it called in T1)
                string text = t1.TransformText();
                
                // in real world, unfortunetly, I need an option to write generated 
                // text to file after T2 generation complete, but before T1 will finish 
                // his work.
            }
        }
    }
}
